from flask_sqlalchemy import SQLAlchemy

db = SQLAlchemy()


class Sample(db.Model):
    uuid = db.Column(db.String(36), primary_key=True)
    name = db.Column(db.String(), nullable=False)
    path = db.Column(db.String(), nullable=False)
    uploader = db.Column(db.String(), nullable=False)
    approved = db.Column(db.Boolean, index=True)
    rejectionMessage = db.Column(db.String(), nullable=True)
    transient = db.Column(db.Boolean, nullable=False)
    progress = db.Column(db.Float, nullable=True)

    def __init__(self, uuid, name, path, uploader, transient=False, progress=None):
        self.uuid = uuid
        self.name = name
        self.path = path
        self.uploader = uploader
        self.approved = False
        self.rejectionMessage = None
        self.transient = transient
        self.progress = progress

    def __repr__(self):
        return '<Sample "{}": approved = {}, id = {}>'.format(self.name, self.approved, self.uuid)
